
/* version 1.0 */
*6/26/00 version

#delimit;


/* This program was originally written by Anne Sartori    */
/* The program was modified by Shigeo Hirano on May 22nd. */


program define sartsel;
version 7;

   syntax varlist(min=2) [, corr(real 1)];
   tokenize `varlist';
   if `corr' != 1 & `corr' != -1 {
      display "Correlation must be 1 or -1. Correlation set to default (1).";
      local corr = 1;
   };
   display "Correlation (rho) (Default = 1): "`corr';
   tempvar depv;
   local dv = "`1'";
   gen `depv' = `dv';   
   local Y3 "`1'";
   macro shift 1;
   local X "`*'";

      if `corr' == 1 {;        /* if rho is 1 then do max likelihood with sartsel_pos */
          ml model lf sartselpos (Selection:`Y3' =  `X' ) 
                   (Outcome:`X' );
           *can take out search and put in ml init matname, copy;
           ml search;
           ml maximize, difficult;
      };

      if `corr' == -1 {;       /* if rho is -1 then do max likelihood with sartselneg.ado */
          ml model lf sartselneg (Selection:`Y3' =  `X' )  
                   (Outcome:`X' );
           *can take out search and put in ml init matname, copy;
           ml search;
           ml maximize, difficult;
      };
      quietly {;
        matrix coef = e(b);
        matrix par = colsof(coef);
        local param = par[1,1];
        local p = `param'/2;
        local p1 = `p'+1;
        local p2 = `param';
        tempvar xgam xbeta check;
        matrix coefg = coef[1,1..`p'];
        matrix coefb = coef[1,`p1'..`p2'];
        matrix score `xgam' = coefg;          /* generating x*gamma col vector for each obs */
        matrix score `xbeta' = coefb;         /* generating x*beta col vector for each obs */
 
        /* check to see whether restrictions all for estimation */
        if `corr' == -1 {;      
           gen `check' = `xgam' + `xbeta';  /* generates  x*gamma + x*beta */
           sum `check' if `depv' == 2;      /* summarizes x*gamma+x*beta for Y = 2 */
           local low = _result(5);          /* saves min value x*gamma+x*beta for Y = 2 */
        };
        if `corr' == 1 {;                   /* generates  x*gamma + x*beta */
           gen `check' = `xgam' - `xbeta';  /* summarizes x*gamma-x*beta for Y = 1 */
           sum `check' if `depv' == 1;      /* saves min value x*gamma+x*beta for Y = 1 */
           local low = _result(5);
        };
        if `low' <= 0 {              /* if the min values are less than 0 then failed robustness */
           noi disp "";
           noi disp "Violated robustness check. Do not use estimates.";
        };
      };  

end;

